Attribute VB_Name = "basQwikPH"
Option Explicit

Public bMain As Boolean, bInt As Boolean, bPH As Boolean
Public bIntLow As Boolean, bIntHigh As Boolean
Public sMain As String, sInt As String, sIntLow As String, sIntHigh As String
Public iMain As Long, iIntLow As Long, iIntHigh As Long
Public sMPLAB_Path As String
Public iLastHeight As Single

' Constants
Public Const wRatio1 = 0.4925373
Public Const wSize1 = 105
Public Const wSize2 = 210
Public Const tSize1 = 30
Public Const tSize2 = 45
Public Const tSize3 = 1050

' Constants for Windows 32-bit Registry API
Private Const ERROR_SUCCESS = 0&
Private Const HKEY_LOCAL_MACHINE = &H80000002

Private Const DELETE = &H10000
Private Const READ_CONTROL = &H20000
Private Const WRITE_DAC = &H40000
Private Const WRITE_OWNER = &H80000
Private Const SYNCHRONIZE = &H100000
Private Const STANDARD_RIGHTS_READ = (READ_CONTROL)
Private Const STANDARD_RIGHTS_WRITE = (READ_CONTROL)
Private Const STANDARD_RIGHTS_EXECUTE = (READ_CONTROL)
Private Const STANDARD_RIGHTS_REQUIRED = &HF0000
Private Const STANDARD_RIGHTS_ALL = &H1F0000
Private Const SPECIFIC_RIGHTS_ALL = &HFFFF
Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_SET_VALUE = &H2
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const KEY_CREATE_LINK = &H20
Private Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
Private Const KEY_WRITE = ((STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY) And (Not SYNCHRONIZE))
Private Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))
Private Const KEY_EXECUTE = ((KEY_READ) And (Not SYNCHRONIZE))

Public Const CREATE_NEW_CONSOLE As Long = &H10
Public Const NORMAL_PRIORITY_CLASS As Long = &H20
Public Const INFINITE As Long = -1
Public Const STARTF_USESHOWWINDOW As Long = &H1
Public Const SW_SHOWNORMAL As Long = 1

Public Const MAX_PATH As Long = 260
Public Const ERROR_FILE_NO_ASSOCIATION As Long = 31
Public Const ERROR_FILE_NOT_FOUND As Long = 2
Public Const ERROR_PATH_NOT_FOUND As Long = 3
Public Const ERROR_FILE_SUCCESS As Long = 32 'my constant
Public Const ERROR_BAD_FORMAT As Long = 11


' Type Declarations
Public Type STARTUPINFO
  cb As Long
  lpReserved As String
  lpDesktop As String
  lpTitle As String
  dwX As Long
  dwY As Long
  dwXSize As Long
  dwYSize As Long
  dwXCountChars As Long
  dwYCountChars As Long
  dwFillAttribute As Long
  dwFlags As Long
  wShowWindow As Integer
  cbReserved2 As Integer
  lpReserved2 As Long
  hStdInput As Long
  hStdOutput As Long
  hStdError As Long
End Type

Public Type PROCESS_INFORMATION
  hProcess As Long
  hThread As Long
  dwProcessId As Long
  dwThreadID As Long
End Type


' API functions
Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Public Declare Function CreateProcess Lib "kernel32" Alias "CreateProcessA" (ByVal lpAppName As String, ByVal lpCommandLine As String, ByVal lpProcessAttributes As Long, ByVal lpThreadAttributes As Long, _
   ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, ByVal lpEnvironment As Long, ByVal lpCurrentDirectory As Long, lpStartupInfo As STARTUPINFO, lpProcessInformation As PROCESS_INFORMATION) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Public Declare Function FindExecutable Lib "shell32.dll" Alias "FindExecutableA" (ByVal lpFile As String, ByVal lpDirectory As String, ByVal sResult As String) As Long
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long


Private Function GetBrowserName(dwFlagReturned As Long) As String
  Dim hFile As Long, sResult As String, i As Integer

  hFile = FreeFile
    Open App.Path & "\dummy.html" For Output As #hFile
  Close #hFile

  sResult = Space$(MAX_PATH)
  dwFlagReturned = FindExecutable("dummy.html", App.Path, sResult)

  Kill App.Path & "\dummy.html"

  i = InStr(sResult, Chr$(0))
  If i Then sResult = Left$(sResult, i - 1)

  GetBrowserName = sResult
End Function

Public Function GetMPLABPath() As String
  Dim nRet As Long, hKey As Long, nType As Long, nBytes As Long
  Dim Buffer As String, sTemp As String

  sTemp = ""

  nRet = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\MPLAB", 0&, KEY_ALL_ACCESS, hKey)
  If nRet = ERROR_SUCCESS Then
    nRet = RegQueryValueEx(hKey, "UninstallString", 0&, nType, ByVal Buffer, nBytes)

    If nRet = ERROR_SUCCESS Then
      If nBytes > 0 Then
        Buffer = Space(nBytes)
        nRet = RegQueryValueEx(hKey, "UninstallString", 0&, nType, ByVal Buffer, Len(Buffer))

        If nRet = ERROR_SUCCESS Then
          sTemp = Left(Buffer, nBytes - 1)
        End If
      End If

      Call RegCloseKey(hKey)
    End If
  End If

  If sTemp <> "" Then
    sTemp = Mid(sTemp, InStr(1, LCase(sTemp), ".exe") + 5)
    sTemp = Left(sTemp, InStr(1, LCase(sTemp), "install.log") - 1)
  End If

  GetMPLABPath = sTemp
End Function

Public Sub FixFile(sFName As String, iType As Integer)
  Dim iByte(2) As Byte, sBackup As String

  If iType > 0 Then
    sBackup = MakeBackup(sFName)

    Open sBackup For Binary Access Read As #1
    Open sFName For Binary Access Write As #2

    Do While Not EOF(1)
      Get #1, , iByte(0)

      Select Case iType
        Case 1
          If iByte(0) = 10 Then
            Put #2, , CByte(13)
          Else
            Put #2, , iByte(0)
          End If

        Case 2
          If Not EOF(1) And iByte(0) = 13 Then
            Get #1, , iByte(1)

            If Not EOF(1) Then
              Get #1, , iByte(2)

              If iByte(1) = 13 And iByte(2) = 10 Then
                Put #2, , CByte(13)
                Put #2, , CByte(10)
              Else
                Put #2, , iByte(0)
                Put #2, , iByte(1)
                Put #2, , iByte(2)
              End If
            Else
              Put #2, , iByte(0)
              Put #2, , iByte(1)
            End If
          Else
            Put #2, , iByte(0)
          End If
      End Select
    Loop

    Close #1
    Close #2
  End If
End Sub

Public Sub LaunchBrowser(sURL As String)
  Dim success As Long, hProcess As Long, sBrowser As String
  Dim start As STARTUPINFO, proc As PROCESS_INFORMATION

  sBrowser = GetBrowserName(success)

  If success >= ERROR_FILE_SUCCESS Then
    With start
      .cb = Len(start)
      .dwFlags = STARTF_USESHOWWINDOW
      .wShowWindow = SW_SHOWNORMAL
    End With

    success = CreateProcess(sBrowser, " " & sURL, 0&, 0&, 0&, NORMAL_PRIORITY_CLASS, 0&, 0&, start, proc)

    Call CloseHandle(proc.hProcess)
    Call CloseHandle(proc.hThread)
  Else
    MsgBox "Error opening " & sURL & "!", vbExclamation
  End If
End Sub

Public Sub LaunchEmail(sURL As String)
  Dim lErr As Long, sMsg As String

  lErr = ShellExecute(0, "open", sURL, "", App.Path, 0)

  If lErr < 32 Then
    sMsg = "Error opening " & sURL & "!"

    If lErr = 2 Then sMsg = "Could not find " & sURL & "!"
    If lErr = 31 Then sMsg = "Could not find email client!"

    MsgBox sMsg, vbExclamation
  End If
End Sub


Public Function MakeBackup(sFName As String) As String
  Dim sBackup As String, iBackup As Integer

  iBackup = 0
  sBackup = Left(sFName, Len(sFName) - 3)

  Do While Len(Dir(sBackup & Format(iBackup, "000"))) > 0
    iBackup = iBackup + 1
  Loop

  sBackup = sBackup & Format(iBackup, "000")
  Name sFName As sBackup

  MakeBackup = sBackup
End Function


Public Function CleanString(sString As String) As String
    'Replace tabs with spaces
    Do While InStr(1, sString, vbTab) > 0
        Mid(sString, InStr(1, sString, vbTab), 1) = " "
    Loop

    'Replace commas with spaces
    Do While InStr(1, sString, ",") > 0
        Mid(sString, InStr(1, sString, ","), 1) = " "
    Loop

    'Replace colons with spaces
    Do While InStr(1, sString, ":") > 0
        Mid(sString, InStr(1, sString, ":"), 1) = " "
    Loop

    'Strip comments
    If InStr(1, sString, ";") > 0 Then sString = Left(sString, InStr(1, sString, ";") - 1)
    sString = RTrim(sString)

    'Remove extra spaces
    Do While InStr(1, sString, "  ") > 0
        sString = Left(sString, InStr(1, sString, "  ")) & Mid(sString, InStr(1, sString, "  ") + 2)
    Loop

    CleanString = sString
End Function

Public Function CheckFormat(sFName As String) As Integer
  Dim iType As Integer, iByte As Byte

  iType = 0 'Assume DOS format

  Open sFName For Binary Access Read As #1

  Do While Not EOF(1)
    Get #1, , iByte

    If iByte = 10 Then
      iType = 1
      Exit Do
    ElseIf iByte = 13 Then
      If Not EOF(1) Then
        Get #1, , iByte

        If iByte = 13 And Not EOF(1) Then
          Get #1, , iByte

          If iByte = 10 Then iType = 2
        End If
      End If

      Exit Do
    End If
  Loop

  Close #1

  CheckFormat = iType    'Return 0 if DOS format
End Function


